/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#include "Interlock.h"

Interlock::Interlock() {
	updated=false;
}


void Interlock::updateStatus(String msg) {

	//Serial.println(msg);
	updated=true;
	int oldi=0;
	int i=msg.indexOf(' ',oldi);
	while (i>0) {
		setValue(msg.substring(oldi,i));
		oldi=i+1;
		i=msg.indexOf(' ',oldi+1);
	}	
	//get the last element
	i=msg.indexOf('\n',oldi);
	setValue(msg.substring(oldi,i));
	/*
	Serial.println(timeout);
	Serial.println(acc_txreq_enable);
	Serial.println(rca_txreq_enable); 
	Serial.println(acc_txreq_polarity);
	Serial.println(rca_txreq_polarity);
	Serial.println(tx1_enabled);
	Serial.println(tx1_delay);
	Serial.println(tx2_enabled);
	Serial.println(tx2_delay); 
	Serial.println(tx3_enabled);
	Serial.println(tx3_delay);
	Serial.println(acc_tx_enabled);
	Serial.println(acc_tx_delay);
	Serial.println(tx_delay);
	Serial.println(state);
	Serial.println(reason); 
	Serial.println(source); 
	*/
}

void Interlock::setValue(String msg){
	int i=msg.indexOf('=');
	if (i>0) {
	    String var=msg.substring(0,i);
		//Serial.println(var);
		
		if (var.equals("timeout")) { timeout=msg.substring(i+1).toInt(); return; }
		if (var.equals("acc_txreq_enable")) { acc_txreq_enable=msg.substring(i+1).toInt(); return; }
		if (var.equals("rca_txreq_enable")) { rca_txreq_enable=msg.substring(i+1).toInt(); return; } 
		if (var.equals("acc_txreq_polarity")) { acc_txreq_polarity=msg.substring(i+1).toInt(); return; }
		if (var.equals("rca_txreq_polarity")) { rca_txreq_polarity=msg.substring(i+1).toInt(); return; }
		if (var.equals("tx1_enabled")) { tx1_enabled=msg.substring(i+1).toInt(); return; }
		if (var.equals("tx1_delay")) { tx1_delay=msg.substring(i+1).toInt(); return; }
		if (var.equals("tx2_enabled")) { tx2_enabled=msg.substring(i+1).toInt(); return; }
		if (var.equals("tx2_delay")) { tx2_delay=msg.substring(i+1).toInt(); return; }
		if (var.equals("tx3_enabled")) { tx3_enabled=msg.substring(i+1).toInt(); return; }
		if (var.equals("tx3_delay")) { tx3_delay=msg.substring(i+1).toInt(); return; }
		if (var.equals("acc_tx_enabled")) { acc_tx_enabled=msg.substring(i+1).toInt(); return; }
		if (var.equals("acc_tx_delay")) { acc_tx_delay=msg.substring(i+1).toInt(); return; }
		if (var.equals("tx_delay")) { tx_delay=msg.substring(i+1).toInt(); return; }		
		if (var.equals("state")) { state=msg.substring(i+1); return; }
		if (var.equals("reason")) { reason=msg.substring(i+1); return; }
		if (var.equals("source")) { source=msg.substring(i+1); return; }
		
	}
}

void Interlock::updateObject(int objectId,int value){
	switch(objectId) {
	//	case RADIO_MIXER_LINEOUT_GAIN:
	//		 break;
		default:
			 Serial.print("Interlock::updateObject - Unhandled id:"); Serial.println(objectId);
	}

}
