/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#ifndef Interlock_h
#define Interlock_h
#include "Arduino.h"

class Interlock
{
  public:
    //properties
	int timeout; //=0 
	int acc_txreq_enable; //=0 
	int rca_txreq_enable; //=0 
	int acc_txreq_polarity; //=0
	int rca_txreq_polarity; //=0
	int tx1_enabled; //=1 
	int tx1_delay; //=0 
	int tx2_enabled; //=1 
	int tx2_delay; //=0 
	int tx3_enabled; //=1 
	int tx3_delay; //=0 
	int acc_tx_enabled; //=1 
	int acc_tx_delay; //=0 
	int tx_delay; //=0
	String state; //TRANSMITTING
	String reason; //
	String source;  //SW

    //methods
    Interlock();
	void updateStatus(String msg);
	void updateObject(int objectId,int value);  //Update specific interlock object	
	boolean updated;
  private:
    //properties
	
    //methods	
	void setValue(String msg);
};
	
#endif