/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#include "Panadapter.h"

Panadapter::Panadapter() {
	updated=false;
}


void Panadapter::updateStatus(String msg) {
	
	//Serial.println(msg);
	updated=true;
	int oldi=0;
	int i=msg.indexOf(' ',oldi);
	while (i>0) {
		setValue(msg.substring(oldi,i));
		oldi=i+1;
		i=msg.indexOf(' ',oldi+1);
	}	
	//get the last element
	i=msg.indexOf('\n',oldi);
	setValue(msg.substring(oldi,i));
	/*
	Serial.println(pan); 
	Serial.println(x_pixels); 
	Serial.println(y_pixels);
	Serial.println(center);
	Serial.println(bandwidth);
	Serial.println(min_dbm); 
	Serial.println(max_dbm);
	Serial.println(fps);
	Serial.println(average);
	Serial.println(weighted_average);
	Serial.println(rfgain);
	Serial.println(rxant);
	Serial.println(wide); 
	Serial.println(loopa);
	Serial.println(loopb); 
	Serial.println(band);
	Serial.println(daxiq);
	Serial.println(daxiq_rate); 
	Serial.println(capacity); 
	Serial.println(available);
	Serial.println(waterfall);
	Serial.println(min_bw);
	Serial.println(max_bw);
	Serial.println(xvtr); 
	Serial.println(pre); 
	Serial.println(ant_list);
	*/
}

void Panadapter::setValue(String msg){
	int i=msg.indexOf('=');
	if (i>0) {
	    String var=msg.substring(0,i);
		//Serial.println(var);
		
		//if (var.equals("pan")) {Serial.println(msg.substring(i+3)); return;} //IT IS HEX value indeed!!!
		if (var.equals("x_pixels")) { x_pixels=msg.substring(i+1).toInt(); return; } 
		if (var.equals("y_pixels")) { y_pixels=msg.substring(i+1).toInt(); return; } 
		if (var.equals("center")) { center=msg.substring(i+1).toFloat()*1000000; return; } 
		if (var.equals("bandwidth")) { bandwidth=msg.substring(i+1).toFloat()*1000000; return; } 
		if (var.equals("min_dbm")) { min_dbm=msg.substring(i+1).toFloat()*10000; return; } 
		if (var.equals("max_dbm")) { max_dbm=msg.substring(i+1).toFloat()*10000; return; } 
		if (var.equals("fps")) { fps=msg.substring(i+1).toInt(); return; }
		if (var.equals("average")) { average=msg.substring(i+1).toInt(); return; } 
		if (var.equals("weighted_average")) { weighted_average=msg.substring(i+1).toInt(); return; } 
		if (var.equals("rfgain")) { rfgain=msg.substring(i+1).toInt(); return; } 
		if (var.equals("rxant")) { rxant=msg.substring(i+1); return; } 
		if (var.equals("wide")) { wide=msg.substring(i+1).toInt(); return; } 
		if (var.equals("loopa")) { loopa=msg.substring(i+1).toInt(); return; } 
		if (var.equals("loopb")) { loopb=msg.substring(i+1).toInt(); return; } 
		if (var.equals("band")) { band=msg.substring(i+1).toInt(); return; } 
		if (var.equals("daxiq")) { daxiq=msg.substring(i+1).toInt(); return; } 
		if (var.equals("daxiq_rate")) { daxiq_rate=msg.substring(i+1).toInt(); return; } 
		if (var.equals("capacity")) { capacity=msg.substring(i+1).toInt(); return; } 
		if (var.equals("available")) { available=msg.substring(i+1).toInt(); return; } 
		if (var.equals("waterfall")) { waterfall=msg.substring(i+1).toInt(); return; } 
		if (var.equals("min_bw")) { min_bw=msg.substring(i+1).toFloat(); return; }
		if (var.equals("max_bw")) { max_bw=msg.substring(i+1).toFloat(); return; }
		if (var.equals("xvtr")) { xvtr=msg.substring(i+1).toInt(); return; } 
		if (var.equals("pre")) { pre=msg.substring(i+1).toInt(); return; } 
		if (var.equals("ant_list")) { ant_list=msg.substring(i+1); return; }

	}
}

void Panadapter::updateObject(int objectId,int value){
    switch(objectId) {
		case PANADAPTER_AVERAGE:
		    average=value;
			break;
		case PANADAPTER_FPS:
		    fps=value;
			break;
		case PAN_BANDWIDTH:
		    bandwidth=value;
			break;
		case PAN_MIN_DBM:
		    min_dbm=value;
			break;
		case PAN_MAX_DBM:
		    max_dbm=value;
			break;
		default:
			 Serial.print("Panadapter::updateObject - Unhandled id:"); Serial.println(objectId);
	}

}