/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#include "Radio.h"
Radio::Radio() {
	updated=false;
}


void Radio::updateStatus(String msg) {
    
	//Serial.println("Radio::updateStatus");
	
	//Serial.println(msg);
	updated=true;
	int oldi=0;
	int i=msg.indexOf(' ',oldi);
	while (i>0) {
		setValue(msg.substring(oldi,i));
		oldi=i+1;
		i=msg.indexOf(' ',oldi+1);
	}	
	//get the last element
	i=msg.indexOf('\n',oldi);
	setValue(msg.substring(oldi,i));
	
	/*
	Serial.println(slices);
	Serial.println(panadapters);
	Serial.println(lineout_gain);
	Serial.println(lineout_mute);
	Serial.println(headphone_gain);
	Serial.println(headphone_mute);
	Serial.println(remote_on_enabled);
	Serial.println(pll_done);
	Serial.println(freq_error_ppb);
	Serial.println(cal_freq);
	Serial.println(tnf_enabled);
	Serial.println(snap_tune_enabled); 
	*/

}

void Radio::setValue(String msg){
    int i=msg.indexOf('=');
	if (i>0) {
	    String var=msg.substring(0,i);
		//Serial.println(var);
		if (var.equals("slices")) {
			slices=msg.substring(i+1).toInt();
			return;
		}
		if (var.equals("panadapters")) { 
			panadapters=msg.substring(i+1).toInt();
			return; 
		}
		if (var.equals("lineout_gain")) { 
			lineout_gain=msg.substring(i+1).toInt();
			return; 
		}
		if (var.equals("lineout_mute")) { 
			lineout_mute=msg.substring(i+1).toInt();
			return; 
		}
		if (var.equals("headphone_gain")) { 
			headphone_gain=msg.substring(i+1).toInt(); 
			return; 
		}
		if (var.equals("headphone_mute")) { 
			headphone_mute=msg.substring(i+1).toInt(); 
			return; 
		}
		
		if (var.equals("remote_on_enabled")) { remote_on_enabled=msg.substring(i+1).toInt(); return; }
		if (var.equals("pll_done")) { pll_done=msg.substring(i+1).toInt(); return; }
		if (var.equals("freq_error_ppb")) { freq_error_ppb=msg.substring(i+1).toInt(); return; }
		if (var.equals("cal_freq")) { cal_freq=msg.substring(i+1).toFloat()*1000000; return; }
		if (var.equals("tnf_enabled")) { tnf_enabled=msg.substring(i+1).toInt(); return; }
		if (var.equals("snap_tune_enabled")) { snap_tune_enabled=msg.substring(i+1).toInt(); return; } 
		
	}
}

void Radio::updateObject(int objectId,int value){
	switch(objectId) {
		case RADIO_MIXER_LINEOUT_GAIN:
		     this->lineout_gain=value;
			 break;
			 
		case RADIO_MIXER_HEADPHONE_GAIN:
		     this->headphone_gain=value;
			 break;
		default:
			 Serial.print("Radio::updateObject - Unhandled id:"); Serial.println(objectId);
	}

}













